package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CourseModuleBusinessAddBo;
import com.zhongzheng.modules.course.bo.CourseModuleBusinessEditBo;
import com.zhongzheng.modules.course.bo.CourseModuleBusinessQueryBo;
import com.zhongzheng.modules.course.domain.CourseModuleBusiness;
import com.zhongzheng.modules.course.mapper.CourseModuleBusinessMapper;
import com.zhongzheng.modules.course.service.ICourseModuleBusinessService;
import com.zhongzheng.modules.course.vo.CourseModuleBusinessVo;
import com.zhongzheng.modules.grade.service.IClassGradeUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 课程模块适用业务关系Service业务层处理
 *
 * @author hjl
 * @date 2021-10-09
 */
@Service
public class CourseModuleBusinessServiceImpl extends ServiceImpl<CourseModuleBusinessMapper, CourseModuleBusiness> implements ICourseModuleBusinessService {

    @Autowired
    private CourseModuleBusinessMapper courseModuleBusinessMapper;

    @Override
    public CourseModuleBusinessVo queryById(Long id){
        CourseModuleBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, CourseModuleBusinessVo.class);
    }

    @Override
    public List<CourseModuleBusiness> getListById(Long moduleId) {
        return courseModuleBusinessMapper.getListById(moduleId);
    }

    @Override
    public List<CourseModuleBusinessVo> queryList(CourseModuleBusinessQueryBo bo) {
        LambdaQueryWrapper<CourseModuleBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getModuleId() != null, CourseModuleBusiness::getModuleId, bo.getModuleId());
        lqw.eq(bo.getEducationTypeId() != null, CourseModuleBusiness::getEducationTypeId, bo.getEducationTypeId());
        lqw.eq(bo.getBusinessId() != null, CourseModuleBusiness::getBusinessId, bo.getBusinessId());
        lqw.eq(bo.getSubjectId() != null, CourseModuleBusiness::getSubjectId, bo.getSubjectId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseModuleBusinessVo> entity2Vo(Collection<CourseModuleBusiness> collection) {
        List<CourseModuleBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseModuleBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseModuleBusiness> page = (Page<CourseModuleBusiness>)collection;
            Page<CourseModuleBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseModuleBusinessAddBo bo) {
        CourseModuleBusiness add = BeanUtil.toBean(bo, CourseModuleBusiness.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseModuleBusinessEditBo bo) {
        CourseModuleBusiness update = BeanUtil.toBean(bo, CourseModuleBusiness.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseModuleBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
